package templatefuncs

import (
	"time"

	"codeflow.dananglin.me.uk/apollo/spruce/internal/cv"
)

// WithinTimePeriod returns true if the employment's end date is within
// the specified time period.
func WithinTimePeriod(date time.Time) func(d cv.Duration) bool {
	return func(d cv.Duration) bool {
		if d.Present {
			return true
		}

		result, err := d.After(date)
		if err != nil {
			return false
		}

		return result
	}
}
